---
type: api
title: Create or update roles
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana/v8/operation/operation-post-security-roles
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana/v8/operation/operation-post-security-roles
products:
  - Kibana
---

# Create or update roles

- Server: `https://{kibana_url}`

## Paths

- `POST` `/api/security/roles`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/kibana/v8/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/kibana/v8/authentication#basicauth)

## Request Body

`application/json`

- `roles` (map string to object) — required
  Map values (object)
  - `description` (string · max: 2048) — optional
    A description for the role.
  - `elasticsearch` (object) — required
    - `cluster` ([] string) — optional
    - `indices` ([] object) — optional
      - `allow_restricted_indices` (boolean) — optional
        Restricted indices are a special category of indices that are used internally to store configuration data and should not be directly accessed. Only internal system roles should normally grant privileges over the restricted indices. Toggling this flag is very strongly discouraged because it could effectively grant unrestricted operations on critical data, making the entire system unstable or leaking sensitive information. If for administrative purposes you need to create a role with privileges covering restricted indices, however, you can set this property to true. In that case, the names field covers the restricted indices too.
      - `field_security` (map string to string) — optional
      - `names` ([] string · min: 1) — required
      - `privileges` ([] string · min: 1) — required
      - `query` (string) — optional
        A search query that defines the documents the role members have read access to. A document within the specified data streams and indices must match this query in order for it to be accessible by the role members.
    - `remote_cluster` ([] object) — optional
      - `clusters` ([] string · min: 1) — required
      - `privileges` ([] string · min: 1) — required
    - `remote_indices` ([] object) — optional
      - `allow_restricted_indices` (boolean) — optional
        Restricted indices are a special category of indices that are used internally to store configuration data and should not be directly accessed. Only internal system roles should normally grant privileges over the restricted indices. Toggling this flag is very strongly discouraged because it could effectively grant unrestricted operations on critical data, making the entire system unstable or leaking sensitive information. If for administrative purposes you need to create a role with privileges covering restricted indices, however, you can set this property to true. In that case, the names field will cover the restricted indices too.
      - `clusters` ([] string · min: 1) — required
      - `field_security` (map string to string) — optional
      - `names` ([] string · min: 1) — required
      - `privileges` ([] string · min: 1) — required
      - `query` (string) — optional
        A search query that defines the documents the role members have read access to. A document within the specified data streams and indices must match this query in order for it to be accessible by the role members.
    - `run_as` ([] string) — optional
  - `kibana` ([] object · max: 1000) — optional
    - `base` (union string[]) — required
      One of: `string[]`
    - `feature` (map string to string) — optional
    - `spaces` (union [] enum | [] string · default: [
  "*"
]) — optional
      Values: `*`
  - `metadata` (map string to object) — optional

## Response

Indicates a successful call.

## Code Examples

#### Console

```console
POST /api/security/roles
```

#### curl

```curl
curl -X POST "https://{kibana_url}/api/security/roles" \
  -H "kbn-xsrf: true"
```

